5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 .
"${source_path}/build/make/configure.sh"
23 ${toggle_libs} libraries
24 ${toggle_examples} examples
25 ${toggle_docs} documentation
26 ${toggle_unit_tests} unit tests
27 ${toggle_decode_perf_tests} build decoder perf tests with unit tests
28 ${toggle_encode_perf_tests} build encoder perf tests with unit tests
29 --cpu=CPU tune for the specified CPU (ARM: cortex-a8, X86: sse3)
30 --libc=PATH path to alternate libc
31 --size-limit=WxH max size to allow in the decoder
32 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
33 --sdk-path=PATH path to root of sdk (android builds only)
34 ${toggle_fast_unaligned} don't use unaligned accesses, even when
35 supported by hardware [auto]
36 ${toggle_codec_srcs} in/exclude codec library source code
37 ${toggle_debug_libs} in/exclude debug version of libraries
38 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
39 ${toggle_vp8} VP8 codec support
40 ${toggle_vp9} VP9 codec support
41 ${toggle_internal_stats} output of encoder internal stats for debug, if supported (encoders)
42 ${toggle_mem_tracker} track memory usage
43 ${toggle_postproc} postprocessing
44 ${toggle_vp9_postproc} vp9 specific postprocessing
45 ${toggle_multithread} multithreaded encoding and decoding
46 ${toggle_spatial_resampling} spatial sampling (scaling) support
47 ${toggle_realtime_only} enable this option while building for real-time encoding
48 ${toggle_onthefly_bitpacking} enable on-the-fly bitpacking in real-time encoding
49 ${toggle_error_concealment} enable this option to get a decoder which is able to conceal losses
50 ${toggle_coefficient_range_checking}
51 enable decoder to check if intermediate
52 transform coefficients are in valid range
53 ${toggle_runtime_cpu_detect} runtime cpu detection
54 ${toggle_shared} shared library support
55 ${toggle_static} static library support
56 ${toggle_small} favor smaller size over speed
57 ${toggle_postproc_visualizer} macro block / block level visualizers
58 ${toggle_multi_res_encoding} enable multiple-resolution encoding
59 ${toggle_temporal_denoising} enable temporal denoising and disable the spatial denoiser
60 ${toggle_vp9_temporal_denoising}
61 enable vp9 temporal denoising
62 ${toggle_webm_io} enable input from and output to WebM container
63 ${toggle_libyuv} enable libyuv
66 Codecs can be selectively enabled or disabled individually, or by family:
69 --disable-<codec>-encoder
70 --disable-<codec>-decoder
72 Codecs available in this distribution:
74 #restore editor state '
80 for c
in ${CODECS}; do
82 if [ "${family}" != "${last_family}" ]; then
83 [ -z "${str}" ] ||
echo "${str}"
84 str
="$(printf ' %10s:' ${family})"
86 str
="${str} $(printf '%10s' ${c#*_})"
94 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
97 # all_platforms is a list of all supported target platforms. Maintain
98 # alphabetically by architecture, generic-gnu last.
99 all_platforms
="${all_platforms} armv6-darwin-gcc"
100 all_platforms
="${all_platforms} armv6-linux-rvct"
101 all_platforms
="${all_platforms} armv6-linux-gcc"
102 all_platforms
="${all_platforms} armv6-none-rvct"
103 all_platforms
="${all_platforms} arm64-darwin-gcc"
104 all_platforms
="${all_platforms} armv7-android-gcc" #neon Cortex-A8
105 all_platforms
="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
106 all_platforms
="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
107 all_platforms
="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
108 all_platforms
="${all_platforms} armv7-none-rvct" #neon Cortex-A8
109 all_platforms
="${all_platforms} armv7-win32-vs11"
110 all_platforms
="${all_platforms} armv7-win32-vs12"
111 all_platforms
="${all_platforms} armv7s-darwin-gcc"
112 all_platforms
="${all_platforms} mips32-linux-gcc"
113 all_platforms
="${all_platforms} mips64-linux-gcc"
114 all_platforms
="${all_platforms} ppc32-darwin8-gcc"
115 all_platforms
="${all_platforms} ppc32-darwin9-gcc"
116 all_platforms
="${all_platforms} ppc32-linux-gcc"
117 all_platforms
="${all_platforms} ppc64-darwin8-gcc"
118 all_platforms
="${all_platforms} ppc64-darwin9-gcc"
119 all_platforms
="${all_platforms} ppc64-linux-gcc"
120 all_platforms
="${all_platforms} sparc-solaris-gcc"
121 all_platforms
="${all_platforms} x86-android-gcc"
122 all_platforms
="${all_platforms} x86-darwin8-gcc"
123 all_platforms
="${all_platforms} x86-darwin8-icc"
124 all_platforms
="${all_platforms} x86-darwin9-gcc"
125 all_platforms
="${all_platforms} x86-darwin9-icc"
126 all_platforms
="${all_platforms} x86-darwin10-gcc"
127 all_platforms
="${all_platforms} x86-darwin11-gcc"
128 all_platforms
="${all_platforms} x86-darwin12-gcc"
129 all_platforms
="${all_platforms} x86-darwin13-gcc"
130 all_platforms
="${all_platforms} x86-iphonesimulator-gcc"
131 all_platforms
="${all_platforms} x86-linux-gcc"
132 all_platforms
="${all_platforms} x86-linux-icc"
133 all_platforms
="${all_platforms} x86-os2-gcc"
134 all_platforms
="${all_platforms} x86-solaris-gcc"
135 all_platforms
="${all_platforms} x86-win32-gcc"
136 all_platforms
="${all_platforms} x86-win32-vs7"
137 all_platforms
="${all_platforms} x86-win32-vs8"
138 all_platforms
="${all_platforms} x86-win32-vs9"
139 all_platforms
="${all_platforms} x86-win32-vs10"
140 all_platforms
="${all_platforms} x86-win32-vs11"
141 all_platforms
="${all_platforms} x86-win32-vs12"
142 all_platforms
="${all_platforms} x86_64-darwin9-gcc"
143 all_platforms
="${all_platforms} x86_64-darwin10-gcc"
144 all_platforms
="${all_platforms} x86_64-darwin11-gcc"
145 all_platforms
="${all_platforms} x86_64-darwin12-gcc"
146 all_platforms
="${all_platforms} x86_64-darwin13-gcc"
147 all_platforms
="${all_platforms} x86_64-iphonesimulator-gcc"
148 all_platforms
="${all_platforms} x86_64-linux-gcc"
149 all_platforms
="${all_platforms} x86_64-linux-icc"
150 all_platforms
="${all_platforms} x86_64-solaris-gcc"
151 all_platforms
="${all_platforms} x86_64-win64-gcc"
152 all_platforms
="${all_platforms} x86_64-win64-vs8"
153 all_platforms
="${all_platforms} x86_64-win64-vs9"
154 all_platforms
="${all_platforms} x86_64-win64-vs10"
155 all_platforms
="${all_platforms} x86_64-win64-vs11"
156 all_platforms
="${all_platforms} x86_64-win64-vs12"
157 all_platforms
="${all_platforms} universal-darwin8-gcc"
158 all_platforms
="${all_platforms} universal-darwin9-gcc"
159 all_platforms
="${all_platforms} universal-darwin10-gcc"
160 all_platforms
="${all_platforms} universal-darwin11-gcc"
161 all_platforms
="${all_platforms} universal-darwin12-gcc"
162 all_platforms
="${all_platforms} universal-darwin13-gcc"
163 all_platforms
="${all_platforms} generic-gnu"
165 # all_targets is a list of all targets that can be configured
166 # note that these should be in dependency order for now.
167 all_targets
="libs examples docs"
169 # all targets available are enabled, by default.
170 for t
in ${all_targets}; do
171 [ -f "${source_path}/${t}.mk" ] && enable_feature ${t}
174 if ! perl --version >/dev/null; then
175 die "Perl is required to build
"
179 if [ "`cd \"${source_path}\" && pwd`" != "`pwd`" ]; then
180 # test to see if source_path already configured
181 if [ -f "${source_path}/vpx_config.h
" ]; then
182 die "source directory already configured
; run
'make distclean' there first
"
186 # check installed doxygen version
187 doxy_version=$(doxygen --version 2>/dev/null)
188 doxy_major=${doxy_version%%.*}
189 if [ ${doxy_major:-0} -ge 1 ]; then
190 doxy_version=${doxy_version#*.}
191 doxy_minor=${doxy_version%%.*}
192 doxy_patch=${doxy_version##*.}
194 [ $doxy_major -gt 1 ] && enable_feature doxygen
195 [ $doxy_minor -gt 5 ] && enable_feature doxygen
196 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable_feature doxygen
199 # install everything except the sources, by default. sources will have
200 # to be enabled when doing dist builds, since that's no longer a common
202 enabled doxygen && enable_feature install_docs
203 enable_feature install_bins
204 enable_feature install_libs
206 enable_feature static
207 enable_feature optimizations
208 enable_feature fast_unaligned #allow unaligned accesses, if supported by hw
209 enable_feature spatial_resampling
210 enable_feature multithread
211 enable_feature os_support
212 enable_feature temporal_denoising
214 [ -d "${source_path}/..
/include
" ] && enable_feature alt_tree_layout
216 [ -d "${source_path}/${d}" ] && disable_feature alt_tree_layout;
219 if ! enabled alt_tree_layout; then
220 # development environment
221 [ -d "${source_path}/vp8
" ] && CODECS="${CODECS} vp8_encoder vp8_decoder
"
222 [ -d "${source_path}/vp9
" ] && CODECS="${CODECS} vp9_encoder vp9_decoder
"
224 # customer environment
225 [ -f "${source_path}/..
/include
/vpx
/vp8cx.h
" ] && CODECS="${CODECS} vp8_encoder
"
226 [ -f "${source_path}/..
/include
/vpx
/vp8dx.h
" ] && CODECS="${CODECS} vp8_decoder
"
227 [ -f "${source_path}/..
/include
/vpx
/vp9cx.h
" ] && CODECS="${CODECS} vp9_encoder
"
228 [ -f "${source_path}/..
/include
/vpx
/vp9dx.h
" ] && CODECS="${CODECS} vp9_decoder
"
229 [ -f "${source_path}/..
/include
/vpx
/vp8cx.h
" ] || disable_feature vp8_encoder
230 [ -f "${source_path}/..
/include
/vpx
/vp8dx.h
" ] || disable_feature vp8_decoder
231 [ -f "${source_path}/..
/include
/vpx
/vp9cx.h
" ] || disable_feature vp9_encoder
232 [ -f "${source_path}/..
/include
/vpx
/vp9dx.h
" ] || disable_feature vp9_decoder
234 [ -f "${source_path}/..
/lib
/*/*mt.lib
" ] && soft_enable static_msvcrt
237 CODECS="$
(echo ${CODECS} |
tr ' ' '\n')"
238 CODEC_FAMILIES="$
(for c
in ${CODECS}; do echo ${c%_*}; done |
sort |
uniq)"
335 vp9_temporal_denoising
336 coefficient_range_checking
395 vp9_temporal_denoising
396 coefficient_range_checking
405 --disable-codecs) for c in ${CODECS}; do disable_feature $c; done ;;
406 --enable-?*|--disable-?*)
407 eval `echo "$opt" | sed 's/--/action=/;s/-/ option=/;s/-/_/g'`
408 if echo "${EXPERIMENT_LIST}" | grep "^
*$option\$
" >/dev/null; then
409 if enabled experimental; then
410 ${action}_feature $option
412 log_echo "Ignoring
$opt -- not
in experimental mode.
"
415 process_common_cmdline $opt
418 *) process_common_cmdline "$opt"
424 post_process_cmdline() {
427 # If the codec family is disabled, disable all components of that family.
428 # If the codec family is enabled, enable all components of that family.
429 log_echo "Configuring selected codecs
"
430 for c in ${CODECS}; do
431 disabled ${c%%_*} && disable_feature ${c}
432 enabled ${c%%_*} && enable_feature ${c}
435 # Enable all detected codecs, if they haven't been disabled
436 for c in ${CODECS}; do soft_enable $c; done
438 # Enable the codec family if any component of that family is enabled
439 for c in ${CODECS}; do
440 enabled $c && enable_feature ${c%_*}
443 # Set the {en,de}coders variable if any algorithm in that class is enabled
444 for c in ${CODECS}; do
445 enabled ${c} && enable_feature ${c##*_}s
451 enabled child || write_common_config_banner
452 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
454 # For fat binaries, call configure recursively to configure for each
455 # binary architecture to be included.
456 if enabled universal; then
457 # Call configure (ourselves) for each subarchitecture
458 for arch in $fat_bin_archs; do
459 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
463 # The write_common_config (config.mk) logic is deferred until after the
464 # recursive calls to configure complete, because we want our universal
465 # targets to be executed last.
466 write_common_config_targets
467 enabled universal && echo "FAT_ARCHS
=${fat_bin_archs}" >> config.mk
469 # Calculate the default distribution name, based on the enabled features
472 for cf in $CODEC_FAMILIES; do
473 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
474 DIST_DIR="${DIST_DIR}-${cf}"
475 elif enabled ${cf}_encoder; then
476 DIST_DIR="${DIST_DIR}-${cf}cx
"
477 elif enabled ${cf}_decoder; then
478 DIST_DIR="${DIST_DIR}-${cf}dx
"
481 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
482 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
483 ! enabled postproc && ! enabled vp9_postproc && DIST_DIR="${DIST_DIR}-nopost"
484 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
485 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
486 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
488 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt
" || DIST_DIR="${DIST_DIR}md
"
489 DIST_DIR="${DIST_DIR}-${tgt_cc}"
492 if [ -f "${source_path}/build
/make
/version.sh
" ]; then
493 ver=`"$source_path/build
/make
/version.sh
" --bare "$source_path"`
494 DIST_DIR="${DIST_DIR}-${ver}"
495 VERSION_STRING=${ver}
497 VERSION_PATCH=${ver##*.}
499 VERSION_MINOR=${ver##*.}
501 VERSION_MAJOR=${ver%.*}
503 enabled child || cat <<EOF >> config.mk
506 ifeq (\$(MAKECMDGOALS),dist)
507 DIST_DIR?=${DIST_DIR}
509 DIST_DIR?=\$(DESTDIR)${prefix}
511 LIBSUBDIR=${libdir##${prefix}/}
513 VERSION_STRING=${VERSION_STRING}
515 VERSION_MAJOR=${VERSION_MAJOR}
516 VERSION_MINOR=${VERSION_MINOR}
517 VERSION_PATCH=${VERSION_PATCH}
519 CONFIGURE_ARGS=${CONFIGURE_ARGS}
521 enabled child || echo "CONFIGURE_ARGS?
=${CONFIGURE_ARGS}" >> config.mk
524 # Write makefiles for all enabled targets
526 for tgt in libs examples docs solution; do
527 tgt_fn="$tgt-$toolchain.mk
"
529 if enabled $tgt; then
530 echo "Creating makefiles
for ${toolchain} ${tgt}"
531 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
539 if enabled shared; then
540 # Can only build shared libs on a subset of platforms. Doing this check
541 # here rather than at option parse time because the target auto-detect
542 # magic happens after the command line has been parsed.
543 if ! enabled linux; then
545 echo "--enable-shared is only supported on ELF
; assuming this is OK
"
547 die "--enable-shared only supported on ELF
for now
"
551 if [ -z "$CC" ] || enabled external_build; then
552 echo "Bypassing toolchain
for environment detection.
"
553 enable_feature external_build
555 log fake_check_header "$@
"
558 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
560 # Headers common to all environments
568 [ -f "${d##-I}/$header" ] && result=true && break
571 esac && enable_feature $var
573 # Specialize windows and POSIX environments.
576 case $header-$toolchain in
579 esac && enable_feature $var
588 esac && enable_feature $var
596 check_header stdio.h || die "Unable to invoke compiler
: ${CC} ${CFLAGS}"
597 check_ld <<EOF || die "Toolchain is unable to link executables
"
598 int main(void) {return 0;}
600 # check system headers
601 check_header stdint.h
602 check_header pthread.h
603 check_header sys/mman.h
604 check_header unistd.h # for sysconf(3) and friends.
606 check_header vpx/vpx_integer.h -I${source_path} && enable_feature vpx_ports
609 process_toolchain() {
610 process_common_toolchain
612 # Handle universal binaries for this architecture
615 darwin_ver=${tgt_os##darwin}
617 # Snow Leopard (10.6/darwin10) dropped support for PPC
618 # Include PPC support for all prior versions
619 if [ $darwin_ver -lt 10 ]; then
620 fat_bin_archs="$fat_bin_archs ppc32-
${tgt_os}-gcc"
623 # Tiger (10.4/darwin8) brought support for x86
624 if [ $darwin_ver -ge 8 ]; then
625 fat_bin_archs="$fat_bin_archs x86-
${tgt_os}-${tgt_cc}"
628 # Leopard (10.5/darwin9) brought 64 bit support
629 if [ $darwin_ver -ge 9 ]; then
630 fat_bin_archs="$fat_bin_archs x86_64-
${tgt_os}-${tgt_cc}"
636 # Enable some useful compiler flags
638 enabled werror && check_add_cflags -Werror
639 check_add_cflags -Wall
640 check_add_cflags -Wdeclaration-after-statement
641 check_add_cflags -Wdisabled-optimization
642 check_add_cflags -Wpointer-arith
643 check_add_cflags -Wtype-limits
644 check_add_cflags -Wcast-qual
645 check_add_cflags -Wvla
646 check_add_cflags -Wimplicit-function-declaration
647 check_add_cflags -Wuninitialized
648 check_add_cflags -Wunused-variable
651 # libvpx and/or clang have issues with aliasing:
652 # https://code.google.com/p/webm/issues/detail?id=603
653 # work around them until they are fixed
654 check_add_cflags -fno-strict-aliasing
656 *) check_add_cflags -Wunused-but-set-variable ;;
658 enabled extra_warnings || check_add_cflags -Wno-unused-function
662 enabled werror && check_add_cflags -Werror
663 check_add_cflags -Wall
664 check_add_cflags -Wpointer-arith
666 # ICC has a number of floating point optimizations that we disable
667 # in favor of deterministic output WRT to other compilers
668 add_cflags -fp-model precise
671 # Enable extra, harmless warnings. These might provide additional insight
672 # to what the compiler is doing and why, but in general, but they shouldn't
673 # be treated as fatal, even if we're treating warnings as errors.
675 -Wdisabled-optimization
678 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
679 RVCT_EXTRA_WARNINGS="
682 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
683 if enabled extra_warnings; then
684 for w in ${EXTRA_WARNINGS}; do
685 check_add_cflags ${w}
686 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
690 # ccache only really works on gcc toolchains
691 enabled gcc || soft_disable ccache
692 if enabled mips; then
693 enable_feature dequant_tokens
694 enable_feature dc_recon
697 if enabled internal_stats; then
698 enable_feature vp9_postproc
701 # Enable the postbuild target if building for visual studio.
703 vs*) enable_feature msvs
704 enable_feature solution
705 vs_version=${tgt_cc##vs}
709 gen_vcproj_cmd=${source_path}/build/make/gen_msvs_proj.sh
713 gen_vcproj_cmd=${source_path}/build/make/gen_msvs_vcxproj.sh
714 enabled werror && gen_vcproj_cmd="${gen_vcproj_cmd} --enable-werror"
717 all_targets="${all_targets} solution
"
718 INLINE="__forceinline
"
722 # Other toolchain specific defaults
723 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
725 if enabled postproc_visualizer; then
726 enabled postproc || die "postproc_visualizer requires postproc to be enabled
"
729 # Enable unit tests by default if we have a working C++ compiler.
732 soft_enable unit_tests
739 # GTestLog must be modified to use Android logging utilities.
742 # iOS/ARM builds do not work with gtest. This does not match
750 # Some mingw toolchains don't have pthread available by default.
751 # Treat these more like visual studio where threading in gtest
752 # would be disabled for the same reason.
753 check_cxx "$@
" <<EOF && soft_enable unit_tests
756 check_cxx "$@
" <<EOF && soft_enable webm_io
759 check_cxx "$@
" <<EOF && soft_enable libyuv
764 enabled pthread_h && check_cxx "$@
" <<EOF && soft_enable unit_tests
767 check_cxx "$@
" <<EOF && soft_enable webm_io
770 check_cxx "$@
" <<EOF && soft_enable libyuv
775 # libwebm needs to be linked with C++ standard library
776 enabled webm_io && LD=${CXX}
781 ## END APPLICATION SPECIFIC CONFIGURATION
785 print_webm_license ${BUILD_PFX}vpx_config.c "/*" " */"
786 cat <<EOF >> ${BUILD_PFX}vpx_config.c
787 static const char* const cfg = "$CONFIGURE_ARGS";
788 const char *vpx_codec_build_config(void) {return cfg;}